// C Source File
// Created 2/3/2008; 1:19:25 PM

//#include "output.h"
#include "C:\Users\Nick\Documents\C Programming\TI-89 files\MapleCal\MapleCal\Setup\output.h"

// Writes the Tile Sets
void WriteTileSets();
// Writes out all the areas (maps & other stuff)
void WriteAreas();

static char tileGameTag[]={0,'t','i','l','e',0,OTH_TAG};
static char scenarioGameTag[]={0,'a','r','e','a',0,OTH_TAG};

// Writes all the needed files
void WriteFiles()
{
	WriteTileSets();
	WriteAreas();
}

static char tileName[] = "mtile00";
static char scenarioName[] = "marea00";

// Writes the Tile Sets
void WriteTileSets()
{
	uchar i;
	for(i = 0; i < NUM_TILE_SETS; i++)
	{
		tileName[5] = i / 10 + '0';
		tileName[6] = i % 10 + '0';

		SYM_STR filename = SYMSTR(tileName);
		
		SYM_ENTRY *symentry;
		HANDLE saveData;
		MULTI_EXPR *ptr;
		HSym h;
	
		//Step 1: Create the file, deleting whatever file used to be called the filename
		h = SymFind(filename);
		if(h.folder) SymDel(filename);
		h = SymAdd(filename);
		if(!h.folder) return;
	
		//Step 2: Allocate the memory, store save data into the memory, and store the
		//                                file type tag into memory.
		saveData = HeapAlloc(2 + sizeof(uchar) + tileSetSize[i]*sizeof(TILES) + tileSetSize[i]*60*sizeof(unsigned long) + tileSetSize[i]*8*sizeof(unsigned char) + sizeof(tileGameTag));
		if(!saveData)
		{
			SymDel(filename);
			return;
		}
		ptr = HeapDeref(saveData);
		ptr->Size = sizeof(uchar) + tileSetSize[i]*sizeof(TILES) + tileSetSize[i]*60*sizeof(unsigned long) + tileSetSize[i]*8*sizeof(unsigned char) + sizeof(tileGameTag);
	
		memcpy(ptr->Expr, &tileSetSize[i], sizeof(uchar));
		memcpy(ptr->Expr + sizeof(uchar), tileSet[i], tileSetSize[i]*sizeof(TILES));
		memcpy(ptr->Expr + sizeof(uchar) + tileSetSize[i]*sizeof(TILES), tileSprites[i], tileSetSize[i]*60*sizeof(unsigned long));
		memcpy(ptr->Expr + sizeof(uchar) + tileSetSize[i]*sizeof(TILES) + tileSetSize[i]*60*sizeof(unsigned long), miniTileSprites[i], tileSetSize[i]*8*sizeof(unsigned char));
		memcpy(ptr->Expr + sizeof(uchar) + tileSetSize[i]*sizeof(TILES) + tileSetSize[i]*60*sizeof(unsigned long) + tileSetSize[i]*8*sizeof(unsigned char), tileGameTag, sizeof(tileGameTag));
	
		//Step 3: Associate the memory with your newly created file symbol
		symentry = DerefSym(h);
		symentry->handle = saveData;
	}
}

#define Write(X, Y) memcpy(ptr->Expr + dist, X, Y); dist += Y;

// Writes out all the scenarios (maps & other stuff)
void WriteAreas()
{
	ushort z = 0;

	uchar i;
	for(i = 0; i < NUM_AREAS; i++)
	{
		scenarioName[5] = i / 10 + '0';
		scenarioName[6] = i % 10 + '0';

		SYM_STR filename = SYMSTR(scenarioName);
		
		SYM_ENTRY *symentry;
		HANDLE saveData;
		MULTI_EXPR *ptr;
		HSym h;
	
		//Step 1: Create the file, deleting whatever file used to be called the filename
		h = SymFind(filename);
		if(h.folder) SymDel(filename);
		h = SymAdd(filename);
		if(!h.folder) return;

		// Calculate size of file
		long size = sizeof(uchar) + areaSize[i] * sizeof(MAP);

		uchar j;
		for(j = 0; j < areaSize[i]; j++)
		{
			size += a_maps[i][j].mapX * a_maps[i][j].mapY * sizeof(uchar);
			size += a_maps[i][j].numOfDoors * (sizeof(DOOR_DATA) + sizeof(short));
			size += a_maps[i][j].numOfEnemies * sizeof(ENEMY_DATA);
		}
	
		//Step 2: Allocate the memory, store save data into the memory, and store the
		//                                file type tag into memory.
		saveData = HeapAlloc(2 + size + sizeof(scenarioGameTag));
		if(!saveData)
		{
			SymDel(filename);
			return;
		}
		ptr = HeapDeref(saveData);
		ptr->Size = size + sizeof(tileGameTag);
	
		long dist = 0;;

		Write(&areaSize[i], sizeof(uchar));

		for(j = 0; j < areaSize[i]; j++)
		{
			// Write Map
			Write(&a_maps[i][j], sizeof(MAP));

			#ifdef DEBUG
			char str[25];
			ClrScr();
			sprintf(str, "Map %d", j+1);
			DrawStr(0, 0, str, A_NORMAL);
			#endif

			// Write Terrain
			Write(a_maps[i][j].terrain, a_maps[i][j].mapX * a_maps[i][j].mapY * sizeof(uchar));

			#ifdef DEBUG
			sprintf(str, "Terrain: %d x %d", a_maps[i][j].mapX, a_maps[i][j].mapY);
			DrawStr(3, 10, str, A_NORMAL);
			#endif

			// Write DoorI
			Write(a_maps[i][j].doorI, a_maps[i][j].numOfDoors * sizeof(short));

			#ifdef DEBUG
			sprintf(str, "DoorI  : %d", a_maps[i][j].numOfDoors);
			DrawStr(3, 20, str, A_NORMAL);
			#endif

			// Write Door Data
			Write(a_maps[i][j].door, a_maps[i][j].numOfDoors * sizeof(DOOR_DATA));

			#ifdef DEBUG
			sprintf(str, "Door   : %d", a_maps[i][j].numOfDoors);
			DrawStr(3, 30, str, A_NORMAL);
			#endif

			// Write Door Data
			Write(a_maps[i][j].enemies, a_maps[i][j].numOfEnemies * sizeof(ENEMY_DATA));

			#ifdef DEBUG
			sprintf(str, "Enemies: %d", a_maps[i][j].numOfEnemies);
			DrawStr(3, 40, str, A_NORMAL);

			ngetchx();
			#endif
		}

		memcpy(ptr->Expr + size, scenarioGameTag, sizeof(scenarioGameTag));
	
		//Step 3: Associate the memory with your newly created file symbol
		symentry = DerefSym(h);
		symentry->handle = saveData;

		// increase z size for next scenario
		z += areaSize[i];
	}
}
