// Header File
// Created 1/29/2008; 1:12:56 PM

#ifndef __ENEMY_H__
#define __ENEMY_H__

/*#include "globals.h"
#include "item.h"*/

#include "C:\Users\Nick\Documents\C Programming\TI-89 files\MapleCal\MapleCal\globals.h"
#include "C:\Users\Nick\Documents\C Programming\TI-89 files\MapleCal\MapleCal\item.h"

/*#include "C:\Users\Joseph\Desktop\Calculator Programing stuff\Maplecalc\MapleCal\globals.h"
#include "C:\Users\Joseph\Desktop\Calculator Programing stuff\Maplecalc\MapleCal\item.h"*/

enum eSpeed { eSLOWER = -2,     eSLOW = -1,     eNORMAL = 0,     eFAST = 1,     eFASTER = 2, 
          eFLY_SLOWER =  1, eFLY_SLOW =  2, eFLY_NORMAL = 3, eFLY_FAST = 4, eFLY_FASTER = 5 };

#define MAP_ENEMY(I) map[engine.mapI].enemies[I]
#define GET_ENEMY(I) enemies[MAP_ENEMY(I).index]

// Data svaed by maps
typedef struct
{
	uchar index;

	// Spawn box
	ushort box_x0;
	ushort box_y0;
	ushort box_x1;
	ushort box_y1;
	
	short x;
	short y;
	
	short xVel;
	short yVel;
	
	long currentHP;
	ushort deadTime;
	uchar walkTime;
	uchar isJumping;
	
	uchar frame;
	uchar attackTime;
	
	char dir;
} ENEMY_DATA;

typedef struct
{
	uchar index;

	// Spawn box
	ushort box_x0;
	ushort box_y0;
	ushort box_x1;
	ushort box_y1;

} ENEMY_DATA_F;

// Enemies
typedef struct 
{
	// sprite stats
	ushort sprite;
	uchar sprite_len;
	uchar bytes;
	uchar frames;
	
	// enemy stats
	uchar strength;
	uchar defense;
	ushort avoid;
	ushort accuracy;
	ushort spawnTime;
	long maxHP;
	ushort exp;
	char speed;
	char jumpSpeed;
	char walkTime;
	uchar isFlying;
	
	// items dropped
	uchar numItemsDropped;
	DROP *drops;
} ENEMY;

#define NUM_OF_ENEMY 7

// Arrays for enemies
extern ENEMY enemies[NUM_OF_ENEMY];

// Methods
void InitializeEnemies();
void DestructEnemies();

// Checks over-laps with tiles
short CheckEnemyTileOverlap(short x, short y, short w, short h, uchar flying);

// Enemy Data Methods
void Enemy_MoveX(uchar i, short x);
void Enemy_MoveY(uchar i, short y);
void Enemy_MoveVel(uchar i);
void RandomizePosition(uchar i);

unsigned char enemySprite_8[72] = 
{
// Spring Frame 1 [0]
0x18, 0x18, 0x18, 0x00, 
0x08, 0x91, 0x4A, 0x10,
0x08, 0x10, 0x08, 0x34,
0x1C, 0x6A, 0xD7, 0x2C,
0x3C, 0x00, 0x00, 0x00,
0x00, 0x00, 0x24, 0x42,

0x66, 0x5A, 0x66, 0x18, 
0x10, 0x89, 0xD3, 0x89,
0x91, 0x89, 0x76, 0x2C,
0x38, 0x56, 0xEB, 0x34,
0x3C, 0x7E, 0xE7, 0xC3,
0x66, 0x24, 0x24, 0x42,

0x81, 0x81, 0x81, 0xE7, 
0xE7, 0x66, 0x24, 0x66, 
0x66, 0x66, 0x81, 0xC3, 
0xC3, 0x81, 0x00, 0xC3, 
0xC3, 0x81, 0x18, 0x3C, 
0x99, 0xDB, 0xDB, 0xBD
};
unsigned char enemySprite_r_8[72];

unsigned short enemySprite_16[384] = 
{
// Gumba Frame 1 [0]
0x0000, 0x0000, 0x0000, 0x0070, 0x0020,
0x0000, 0x078E, 0x0FC4, 0x0FE2, 0x11F3,
0x19F0, 0x1FF0, 0x3F76, 0x7F62, 0x1F68,
0x0EC8, 0x0000, 0x0FE0, 0x1FF0, 0x3FF0,

0x0000, 0x0000, 0x0000, 0x00F0, 0x03E0,
0x07C0, 0x087E, 0x163C, 0x181E, 0x2C0F,
0x2C0C, 0x200C, 0x408E, 0x7E9A, 0x2098,
0x1138, 0x1FF0, 0x0FE0, 0x1FF0, 0x3FF0,

0xFFFF, 0xFFFF, 0xFFFF, 0xFF0F, 0xFC1F, 
0xF83F, 0xF001, 0xE003, 0xE001, 0xC000, 
0xC003, 0xC003, 0x8001, 0x8005, 0xC007, 
0xE007, 0xE00F, 0xF01F, 0xE00F, 0xC00F,

// Gumba Frame 2 [60]
0x0000, 0x0020, 0x0018, 0x0390, 0x07C0,
0x0FE0, 0x18E3, 0x3CF1, 0x3FF8, 0x2DF8,
0x0D70, 0x2173, 0x7561, 0x3760, 0x1E6C,
0x0DE4, 0x0000, 0x0FE0, 0x1FF0, 0x3FF0,

0x0000, 0x00E0, 0x03F8, 0x0470, 0x0B3C,
0x141E, 0x261F, 0x460D, 0x3004, 0x2A06,
0x0D8E, 0x218F, 0x7599, 0x4F98, 0x219C,
0x121C, 0x0FF0, 0x0FE0, 0x1FF0, 0x3FF0,

0xFFFF, 0xFF1F, 0xFC07, 0xF80F, 0xF003, 
0xE001, 0xC000, 0x8002, 0xC003, 0xD001, 
0xF201, 0xDE00, 0x8A06, 0x8007, 0xC003, 
0xE003, 0xF00F, 0xF01F, 0xE00F, 0xC00F,

// Croc Frame 1 [120]
0x0000, 0x0000, 0x0000, 0x00E8, 0x00A8,
0x22E8, 0x3E08, 0x0038, 0x3F38, 0x0078,
0x0070, 0x0070, 0x0070, 0x21E0, 0x63E0,
0x07E2, 0x0FE2, 0x0FC2, 0x07C2, 0x07C0,
0x0DC0, 0x0B40, 0x1B80, 0x1B80, 0x1B80,
0x04C0, 0x07C4, 0x03EC, 0x0FFC, 0x3F80,

0x0000, 0x00F0, 0x01F8, 0x0154, 0x23B4,
0x7D54, 0x41F4, 0x7FC4, 0x7FC4, 0x3F84,
0x0F88, 0x0188, 0x0088, 0x31D8, 0x7258,
0x3C5A, 0x109A, 0x0F32, 0x0836, 0x0834,
0x1234, 0x14A4, 0x2464, 0x2466, 0x2446,
0x32A6, 0x3AAA, 0x1E92, 0x0E82, 0x3FFC,

0xFFFF, 0xFF0F, 0xFE07, 0xFE03, 0xDC03, 
0x8003, 0x8003, 0x8003, 0x8003, 0xC003, 
0xF007, 0xFE07, 0xFF07, 0xCE07, 0x8C07, 
0xC005, 0xE005, 0xF00D, 0xF009, 0xF00B, 
0xE00B, 0xE01B, 0xC01B, 0xC019, 0xC039, 
0xC019, 0xC011, 0xE001, 0xF001, 0xC003,

// Croc Frame 2 [210]
0x0000, 0x0000, 0x00E8, 0x00A8, 0x22E8,
0x3E08, 0x0038, 0x5538, 0x0038, 0x0078,
0x0070, 0x00F0, 0x01F0, 0x01E0, 0x03E0,
0xC7E1, 0xC7E1, 0x0FC1, 0x07C1, 0x07C0,
0x0DC0, 0x0B40, 0x1B80, 0x1B80, 0x1B80,
0x04C0, 0x07C4, 0x03EC, 0x0FFC, 0x3F80,

0x00F0, 0x01F8, 0x0154, 0x23B4, 0x7D54,
0x41F4, 0x7FC4, 0x55C4, 0x00C4, 0x0184,
0x038C, 0x0708, 0x1E08, 0x1DD8, 0x0258,
0xFC59, 0x5899, 0x0F31, 0x0833, 0x0832,
0x1234, 0x14A4, 0x2464, 0x2466, 0x2446,
0x32A6, 0x3AAA, 0x1E92, 0x0E82, 0x3FFC,

0xFF0F, 0xFE07, 0xFE03, 0xDC03, 0x8003, 
0x8003, 0x8003, 0xAA03, 0xFF03, 0xFE03, 
0xFC03, 0xF807, 0xE007, 0xE207, 0xFC07, 
0x0006, 0x2006, 0xF00E, 0xF00C, 0xF00D, 
0xE00B, 0xE01B, 0xC01B, 0xC019, 0xC039, 
0xC019, 0xC011, 0xE001, 0xF001, 0xC003,

// Slime Frame 1 [300]
0x00E0, 0x01F0, 0x07F8, 0x3E7C, 0x7CF2, 
0xD1E1, 0xF7A3, 0xD3FF, 0xDFFF, 0xCFFB, 
0x61E6, 0x3C3C, 0x1FF8,

0x00E0, 0x0110, 0x0608, 0x3984, 0x4302, 
0xBE01, 0xB8C1, 0xACC1, 0xA001, 0xB005, 
0x5E1A, 0x23C4, 0x1FF8,

0xFF1F, 0xFE0F, 0xF807, 0xC003, 0x8003, 
0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 
0x8001, 0xC003, 0xE007,

// Mushroom Frame 1 [339]
0x0060, 0x0038, 0x3808, 0x4418, 0x0FC0, 
0x1FA2, 0x2C5C, 0x7B54, 0x4014, 0xC014, 
0x801C, 0x801C, 0xC01C, 0x6038, 0x3FF0,

0x07F0, 0x1FC8, 0x6784, 0xBBE6, 0xFFFF, 
0xF03D, 0xF85B, 0x630F, 0x400F, 0x400E, 
0x8004, 0x8004, 0x4008, 0x2010, 0x1FE0,

0xF80F, 0xE007, 0x8003, 0x0001, 0x0000, 
0x0000, 0x0000, 0x8000, 0x8000, 0x0001, 
0x0003, 0x0003, 0x0003, 0x8007, 0xC00F
};
unsigned short enemySprite_r_16[384];

unsigned long enemySprite_32[246] = 
{
// Pig Frame 1 [0]
0x078F0000, 0x07FFC000, 0x06F9E000, 0x06F9F800, 
0x0FFFFE00, 0x0FFFFF00, 0x67FFFF80, 0x5FE3FFC0, 
0x87C1FFE0, 0x87C1FFE0, 0x83E3FFF0, 0xD3FFFFF0, 
0xDBFFFFF8, 0x9BFFFFFF, 0x83FFFFFF, 0x7FFFFFFE, 
0x1FFFFFFC, 0x0FE1FDF0, 0x0781F9F0, 0x00FFFDF0, 
0x010A1220, 0x01F3E3C0,

0x078F0000, 0x04F8C000, 0x05062000, 0x05061800, 
0x08000600, 0x0E000300, 0x641C0180, 0x782200C0, 
0xFC710020, 0xFC710020, 0xFE220030, 0xFE1C0010, 
0xFE000018, 0xFE00780F, 0xFE008403, 0x7C010402, 
0x1001048C, 0x081F0710, 0x07FF8F10, 0x00FF0F90, 
0x01FBF3E0, 0x01F3E3C0,

0xF870FFFF, 0xF8003FFF, 0xF8001FFF, 0xF80007FF, 
0xF00001FF, 0xF00000FF, 0x9800007F, 0x8000003F, 
0x0000001F, 0x0000001F, 0x0000000F, 0x0000000F, 
0x00000007, 0x00000000, 0x00000000, 0x80000001, 
0xE0000003, 0xF000000F, 0xF800000F, 0xFF00000F, 
0xFE040C1F, 0xFE0C1C3F,

//Tent Frame 1 [66]
0x00000000, 0x00000000, 0x00000000, 0x00000000, 
0x00000000, 0x00000000, 0x01C00700, 0x03F08F80, 
0x03F1DFC0, 0x0FB9DC80, 0x0F1DCF00, 0x0E3EEF00, 
0x1C7F7700, 0x1C777380, 0x1CE37700, 0x1DC23F00, 
0x1DC07E40, 0x1DC0FCF0, 0x0EFECFF8, 0x06FFFFF8, 
0x11CFFF9C, 0x3FCF3F1E, 0x3FFF3F3E, 0x1FFFFF1C, 
0x07FFFE08, 0x0FFFFE00, 0x0FC3FF00, 0x0FFC7F00, 
0x0FFFFF00, 0x07FFFF00,

0x00000000, 0x00000000, 0x00000000, 0x00000000, 
0x00000000, 0x00000000, 0x01C00700, 0x02308880, 
0x02515740, 0x0DA95480, 0x09154B00, 0x0A2AA900, 
0x144D5500, 0x14555280, 0x14A35500, 0x15423900, 
0x1D404240, 0x1580BCB0, 0x0AFE4B08, 0x06F9F6E8, 
0x1159EC94, 0x2F79631A, 0x2A79E12A, 0x1E00E314, 
0x04000608, 0x083C0600, 0x087F8300, 0x0803C100, 
0x08000100, 0x07FFFF00,

0xFFFFFFFF, 0xFFFFFFFF, 0xFFFFFFFF, 0xFFFFFFFF, 
0xFFFFFFFF, 0xFFFFFFFF, 0xFE3FF8FF, 0xFC0F707F, 
0xFC0E203F, 0xF046237F, 0xF0E230FF, 0xF1C110FF, 
0xE38088FF, 0xE3888C7F, 0xE31C88FF, 0xE23DC0FF, 
0xE23F81BF, 0xE23F030F, 0xF1013007, 0xF9000007, 
0xEE000063, 0xC00000E1, 0xC00000C1, 0xE00000E3, 
0xF80001F7, 0xF00001FF, 0xF00000FF, 0xF00000FF, 
0xF00000FF, 0xF80000FF,

// Tent Frame 2 [156]
0x00000000, 0x00000000, 0x00000000, 0x00000000, 
0x00000000, 0x00000000, 0x01C00000, 0x03F0F800, 
0x03F0F800, 0x0FB9F860, 0x0F1DD0F0, 0x0E3EE1F8, 
0x1C7F73F8, 0x1C7777FC, 0x1CE37F9E, 0x1DC23F04, 
0x1DC07E40, 0x1DC0EEF8, 0x0EFECFF8, 0x06FFFFFC, 
0x11CFFF9C, 0x3FCF3F3C, 0x3FFF3F7C, 0x1FFFFF38, 
0x07FFFE10, 0x0FFFFE00, 0x0FEBFF00, 0x0FFD7F80, 
0x0FFFFF80, 0x07FFFF00,

0x00000000, 0x00000000, 0x00000000, 0x00000000, 
0x00000000, 0x00000000, 0x01C00000, 0x0230F800, 
0x02508800, 0x0DA9B860, 0x09155090, 0x0A2AA108, 
0x144D5368, 0x145554F4, 0x14A35D9A, 0x15423B04, 
0x1D405A40, 0x1580AEB8, 0x0AFE4B08, 0x06F9F6F4, 
0x1159EC94, 0x2F796334, 0x2A79E154, 0x1E00E328, 
0x04000610, 0x083C0600, 0x08778300, 0x081EC080, 
0x08038080, 0x07FFFF00,

0xFFFFFFFF, 0xFFFFFFFF, 0xFFFFFFFF, 0xFFFFFFFF, 
0xFFFFFFFF, 0xFFFFFFFF, 0xFE3FFFFF, 0xFC0F07FF, 
0xFC0F07FF, 0xF046079F, 0xF0E22F0F, 0xF1C11E07, 
0xE3808C07, 0xE3888803, 0xE31C8061, 0xE23DC0FB, 
0xE23F81BF, 0xE23F1107, 0xF1013007, 0xF9000003, 
0xEE000063, 0xC00000C3, 0xC0000083, 0xE00000C7, 
0xF80001EF, 0xF00001FF, 0xF00000FF, 0xF000007F, 
0xF000007F, 0xF80000FF,
};
unsigned long enemySprite_r_32[246];

#endif // __ENEMY_H__
