// Header File
// Created 1/15/2008; 11:03:18 AM

#ifndef __GLOBALS_H__
#define __GLOBALS_H__

enum dSpeeds { FAST = 0x01, MEDIUM = 0x03, SLOW = 0x07 };
#define DRAW_SPEED FAST

enum UseableFor { HP = 0, MP = 1, HP_and_MP = 2, Speed = 3, Magic = 10, Special = 99 };
enum Job { BEGINNER = 0, WARRIOR = 1, MAGICIAN = 2, BOWMAN = 3 };

//#define SHOW_SPAWN_BOXES
//#define SHOW_DOORS
//#define DRAW_BOXES
//#define DEBUG
//#define DEBUG_AREA_FILE
//#define VIEW_ITEMS
//#define USE_CSTRINGS
#define SHOW_F_KEYS
#define SHOW_EXP
#define SHOW_HP_MP
#define SHOW_AMMO

typedef unsigned long ulong;
typedef unsigned short ushort;
typedef unsigned int uint;
typedef unsigned char uchar;

enum Dir { FORWARD = 1, BACKWARD = -1 };

#define SCREEN_WIDTH 160
#define SCREEN_HEIGHT 100

#define MAP_X map[engine.mapI].mapX
#define MAP_Y map[engine.mapI].mapY
#define MAP_WIDTH (MAP_X*32)
#define MAP_HEIGHT (MAP_Y*30)

#define NUM_BEGINNER_SKILLS 3
#define NUM_WARRIOR_SKILLS  0
#define NUM_BOWMAN_SKILLS   0
#define NUM_MAGICIAN_SKILLS 0

#include <tigcclib.h>

#ifdef DEBUG
void _Assert(short condition, char str[50]);
void _Print(char str[30]);
#define Assert(X) { char str[50] = #X ; _Assert( X, str ); }
#define Print(X) { char str[30]; sprintf(str, "%s = %ld", #X, X); _Print( str ); }
#else
#define Assert(x) ;
#define Print(x) ;
#endif

// End everything
enum ErrorCode { ERROR_NONE = 0, ERROR_MEMORY = 1, ERROR_FILE = 2 };
#define End() _End(0, 0)
#define Crash(X) _End(X, __LINE__)
void _End(uchar error, ushort line);

// Method like macros
#define BOX_OVER_LAP(x1A, y1A, x2A, y2A, x1B, y1B, x2B, y2B) ((x1A) <= (x2B) && (x2A) >= (x1B) && (y1A) <= (y2B) && (y2A) >= (y1B))

#endif // __GLOBALS_H__
