// C Source File
// Created 1/17/2008; 6:59:21 PM

/*#include "graphics.h"
#include "sprites.h"
#include "player.h"
#include "skill.h"
#include "enemy.h"
#include "keys.h"
#include "tiles.h"
#include "map.h"
#include "item.h"
#include "itemtype.h"*/

#include "C:\Users\Nick\Documents\C Programming\TI-89 files\MapleCal\MapleCal\graphics.h"
#include "C:\Users\Nick\Documents\C Programming\TI-89 files\MapleCal\MapleCal\sprites.h"
#include "C:\Users\Nick\Documents\C Programming\TI-89 files\MapleCal\MapleCal\player.h"
#include "C:\Users\Nick\Documents\C Programming\TI-89 files\MapleCal\MapleCal\skill.h"
#include "C:\Users\Nick\Documents\C Programming\TI-89 files\MapleCal\MapleCal\enemy.h"
#include "C:\Users\Nick\Documents\C Programming\TI-89 files\MapleCal\MapleCal\keys.h"
#include "C:\Users\Nick\Documents\C Programming\TI-89 files\MapleCal\MapleCal\tiles.h"
#include "C:\Users\Nick\Documents\C Programming\TI-89 files\MapleCal\MapleCal\map.h"
#include "C:\Users\Nick\Documents\C Programming\TI-89 files\MapleCal\MapleCal\item.h"
#include "C:\Users\Nick\Documents\C Programming\TI-89 files\MapleCal\MapleCal\itemtype.h"

/*#include "C:\Users\Joseph\Desktop\Calculator Programing stuff\Maplecalc\MapleCal\graphics.h"
#include "C:\Users\Joseph\Desktop\Calculator Programing stuff\Maplecalc\MapleCal\sprites.h"
#include "C:\Users\Joseph\Desktop\Calculator Programing stuff\Maplecalc\MapleCal\player.h"
#include "C:\Users\Joseph\Desktop\Calculator Programing stuff\Maplecalc\MapleCal\skill.h"
#include "C:\Users\Joseph\Desktop\Calculator Programing stuff\Maplecalc\MapleCal\enemy.h"
#include "C:\Users\Joseph\Desktop\Calculator Programing stuff\Maplecalc\MapleCal\keys.h"
#include "C:\Users\Joseph\Desktop\Calculator Programing stuff\Maplecalc\MapleCal\tiles.h"
#include "C:\Users\Joseph\Desktop\Calculator Programing stuff\Maplecalc\MapleCal\map.h"
#include "C:\Users\Joseph\Desktop\Calculator Programing stuff\Maplecalc\MapleCal\item.h"
#include "C:\Users\Joseph\Desktop\Calculator Programing stuff\Maplecalc\MapleCal\itemtype.h"*/


// Initializes the engine
void InitEngine();
// Does some initilization to create buffers and return FALSE in case of error
int GraySpriteInit(ulong size_buff);
// Cleans up/deinitilizes gray sprites
void GraySpriteDeInit();
// Creates the reverse sprites
void CreateReverseSprites();
// Updates the player's position
void UpdatePlayer();
// Draws the players
void DrawPlayer();
// Draws a magic attack
void DrawMagic();
// Draws the tiles
void DrawTiles();
// Updates the Enemies Pos
void UpdateEnemies();
// Draws the enemies
void DrawEnemies();
// Draws the floating strings
void DrawFStrings();
// Draws the command (text) strings
void DrawCStrings();
// Gets keys
void GetKeys();
// Loads a map & sets all the necessary variables
void LoadMap(uchar area, uchar i, uchar j);
// Loads a Tile Set
void LoadTileSet(uchar i);
// Draws a mini map
void DrawMiniMap();

// Engine to hold all global variables
ENGINE engine;
	
// Initialize everything
void Init()
{
	GrayAdjust(0);
	FontSetSys(F_4x6);

	// Randomize seed
	randomize();
	
	// Initailize the engine variables
	InitEngine();
	
	// Int Vec
	engine.ai1 = GetIntVec(AUTO_INT_1);
	engine.ai5 = GetIntVec(AUTO_INT_5);
	SetIntVec(AUTO_INT_1,DUMMY_HANDLER);
	SetIntVec(AUTO_INT_5,DUMMY_HANDLER);
	
	// Set up for gray scale
	if(!GraySpriteInit(3840)) exit(0);
	
	// set up ports
	clrscr();
	PortSet(engine.light_vscreen, 239, 127); clrscr();
	PortSet(engine.dark_vscreen,  239, 127); clrscr();
	
	// Creates the reverse sprites
	CreateReverseSprites();
	
	// Initializes the tiles
	InitializeTiles();
	
	// initialize the enemies
	InitializeEnemies();
	
	// Initializes the maps
	InitializeMaps();
	
	// initialize player
	InitializePlayer();
	
	// initialize all the items
	InitializeItems();
	CreateItemTypes();
	
	// keys
	InitKeys();

	if(!QuickLoad())
	{
		// Goes through character creation
		CreatePlayer();

		// Loads the first map
		LoadMap(0, 0, 0);
	}
	else
	{
		// Loads the correct area
		LoadArea(++engine.area - 1);

		// Loads the correct tile set
		LoadTileSet(++engine.tileSet - 1);

		// Reset all the enemy vars
		ResetMapEnemies();
	}
}

// End everything
void _End(uchar error, ushort line)
{
	if(error)
	{
		ClearBuffers();

		char str[40];
		switch(error)
		{
		case ERROR_MEMORY: sprintf(str, "Memory Error. Line %hd", line);  break;
		case ERROR_FILE:   sprintf(str, "File Error. Line %hd", line);    break;
		default:           sprintf(str, "Unknown Error. Line %hd", line); break;
		}

		DrawGrayStr2B(50, 40, str, A_NORMAL, engine.light_vscreen, engine.dark_vscreen);

		CopyBuffers();

		while(!keys.Enter && !keys.Esc && !keys._2nd)
			ScanKeys();
	}

	GraySpriteDeInit();
	PortSet(LCD_MEM, 239, 127);
	clrscr();
	
	SetIntVec(AUTO_INT_1,engine.ai1);
	SetIntVec(AUTO_INT_5,engine.ai5);
	
	DestructMaps();
	DestructEnemies();
	DestructTiles();
	
	exit(0);
}

// Initializes the engine
void InitEngine()
{
	engine.light_vscreen = NULL;
	engine.dark_vscreen = NULL;
	engine.tileSet = 255;
}

//does some initilization to create buffers and return FALSE in case of error
int GraySpriteInit(ulong size_buff) 
{
	engine.light_vscreen = malloc(size_buff);
	if(!engine.light_vscreen) return 0;
	
	engine.dark_vscreen = malloc(size_buff);
	if(!engine.dark_vscreen) 
	{
		free(engine.light_vscreen); 
		return 0;
	}
	memset(engine.light_vscreen, 0x00, size_buff);
	memset(engine.dark_vscreen, 0x00, size_buff);
	
	GrayOn();
	if(!IsGrayMode()) 
	{
		free(engine.light_vscreen); 
		free(engine.dark_vscreen); 
		GrayOff(); 
		return 0;
	}
	
	return 1;
}

//cleans up/deinitilizes gray sprites
void GraySpriteDeInit() 
{
	free(engine.light_vscreen);
	free(engine.dark_vscreen);
	GrayOff();
}

// Reverses the sprites
void CreateReverseSprites()
{
	SpriteX8_MIRROR_H(HEADS*45, (uchar*)head,  2, (uchar*)head_r);
	SpriteX8_MIRROR_H(BODYS*60, (uchar*)body,  2, (uchar*)body_r);
	SpriteX8_MIRROR_H(ARMS*144, (uchar*)arm,   4, (uchar*)arm_r);
	SpriteX8_MIRROR_H(9,        (uchar*)arrow, 1, (uchar*)arrow_r);
	SpriteX8_MIRROR_H(1*2*15,   (uchar*)magicSprites, 2, (uchar*)magicSprites_r);
}

// Draws a mini map
void DrawMiniMap()
{
	// Clear buffer screens
	ClearBuffers();

	DrawGrayRect2B(9, 9, 10 + 4*MAP_X, 10 + 4*MAP_Y, COLOR_BLACK, 0, engine.light_vscreen, engine.dark_vscreen);

	uchar i, j;
	for(i = 0; i < MAP_X; i++)
	for(j = 0; j < MAP_Y; j++)
	{
		GrayClipSprite8_XOR_R(i*4 + 10, j*4 + 10, 4, &miniTileSprites[MAP_TILE(j, i).sprite*8], &miniTileSprites[MAP_TILE(j, i).sprite*8]+4, engine.light_vscreen, engine.dark_vscreen);
	}
		
	// Copy over buffer screen
	CopyBuffers();

	do
	{
		ScanKeys();
	} while(!keys.Esc);
}

// Main loop for drawing
void DrawLoop()
{
	while(1)
	{
		// Clear buffer screens
		ClearBuffers();
		
		// Update
		if((engine.iteration & DRAW_SPEED) == 0)
		{
			UpdatePlayer();
			GetKeys();
			UpdateEnemies();
		}
		
		// Draws the background
		DrawTiles();
		
		// Players
		DrawPlayer();
		
		// Draws the enemies
		DrawEnemies();
		
		// Arrows
		MoveArrows();
		DrawArrows();
		
		// Draws the dropped items
		DrawItemDrops();
		
		// Checks to see if Player hits something that causes damage
		#ifndef DRAW_FASTER
		if((engine.iteration & DRAW_SPEED) == 0)
		#endif
			CheckPlayerDamage();
		
		// Draws all the statistics to the screen
		DrawPlayerStats();
		
		// Draws all of the damage strings to the screen
		DrawFStrings();
#ifdef USE_CSTRINGS
		DrawCStrings();
#endif
		
		// Copy over buffer screen
		CopyBuffers();
		
		// Completed an iteration
		if(engine.iteration == 255) engine.iteration = 0;
		else                        engine.iteration++;
	}
}

// Updates the player
void UpdatePlayer()
{
	// Gravity
	AccelerateY(-2);
	player.jump_time++;
	player.still_time++;
	if(player.immune_time > 0)
		player.immune_time--;
	
	if(player.still_time > 65)
	{
		player.still_time = 0;
		
		player.health = min(player.health + 10, player.maxHealth);
		player.magic  = min(player.magic + 5,   player.maxMagic);

		char str[9];
		sprintf(str, "+%d", 10);
		NewFString(str, player.xPos + engine.x, player.yPos + engine.y - 10);
	}

	// Experience required for a certain level
	if(player.experience >= GetRequiredExp(player.level))
	{
		char str[9] = "Level Up";
		NewFString(str, player.xPos + engine.x, player.yPos + engine.y - 10);

		switch(player.job)
		{
		case BEGINNER:
			player.maxHealth += 7 * player.strength;
			player.maxMagic += 5 * player.intelligence;
			break;
		case WARRIOR:
			player.maxHealth += 8 * player.strength;
			player.maxMagic += 5 * player.intelligence;
			break;
		case MAGICIAN:
			player.maxHealth += 20 * player.strength;
			player.maxMagic += 7 * player.intelligence;
			break;
		case BOWMAN:
			player.maxHealth += 10 * player.strength;
			player.maxMagic += 6 * player.intelligence;
			break;
		}

		player.health = player.maxHealth;
		player.magic = player.maxMagic;

		player.experience -= GetRequiredExp(player.level);
		player.level++;
		player.lPoints += 5;
	}
	
	MoveVel();
}

// Draws the players
void DrawPlayer()
{
	uchar weap = iWeapon[items[player.weapon].useIndex].spriteIndex;
	uchar armor = iArmor[items[player.armor].useIndex].spriteIndex;

	if(player.direction == FORWARD)
	{
		GrayClipSprite16_SMASK_R(player.xPos,   player.yPos,    15, head[player.head],        head[player.head]+15,        head[player.head]+30,        engine.light_vscreen, engine.dark_vscreen);
		GrayClipSprite16_SMASK_R(player.xPos,   player.yPos+15, 20, body[armor],              body[armor]+20,              body[armor]+40,              engine.light_vscreen, engine.dark_vscreen);
		GrayClipSprite32_SMASK_R(player.xPos+3, player.yPos+10, 16, arm[weap][player.attack], arm[weap][player.attack]+16, arm[weap][player.attack]+32, engine.light_vscreen, engine.dark_vscreen);
	}
	else
	{
		GrayClipSprite16_SMASK_R(player.xPos,    player.yPos,    15, head_r[player.head],        head_r[player.head]+15,        head_r[player.head]+30,        engine.light_vscreen, engine.dark_vscreen);
		GrayClipSprite16_SMASK_R(player.xPos,    player.yPos+15, 20, body_r[armor],              body_r[armor]+20,              body_r[armor]+40,              engine.light_vscreen, engine.dark_vscreen);
		GrayClipSprite32_SMASK_R(player.xPos-19, player.yPos+10, 16, arm_r[weap][player.attack], arm_r[weap][player.attack]+16, arm_r[weap][player.attack]+32, engine.light_vscreen, engine.dark_vscreen);
	}
		
	#ifdef DRAW_BOXES
	DrawGrayRect2B(player.xPos, player.yPos, player.xPos+15, player.yPos+34, COLOR_BLACK, 0, engine.light_vscreen, engine.dark_vscreen);
	#endif
	
	Attack();
	DrawMagic();
}

// Draws a magic attack
void DrawMagic()
{
	if(player.magic_time)
	{
		player.magic_time--;

		uchar i;
		uchar j = ((player.magic_time & 0x04) != 0);

		if(player.direction == FORWARD)
		{
			for(i = 0; i < 2; i++)
				GrayClipSprite16_SMASK_R(player.xPos+20+i*16, player.yPos+20, 5, magicSprites[player.spell][j], magicSprites[player.spell][j]+5, magicSprites[player.spell][j]+10, engine.light_vscreen, engine.dark_vscreen);
		}
		else
		{
			for(i = 0; i < 2; i++)
				GrayClipSprite16_SMASK_R(player.xPos-21-i*16, player.yPos+20, 5, magicSprites_r[player.spell][j], magicSprites_r[player.spell][j]+5, magicSprites_r[player.spell][j]+10, engine.light_vscreen, engine.dark_vscreen);
		}
	}

	MagicAttack();
}

// Draws the tiles
void DrawTiles()
{
	// starts at the first tile that either completely or just partly shows up on the left side
	// then determine the last tile to be drawn and goes through each and draws them
	short xI = engine.x>>5;
	short yI = (engine.y/30);
	short x;
	short xF = xI + (((engine.x&31) == 0) ? 5 : 6);
	short yF = yI + (((engine.y - yI*30) < 20) ? 4 : 5);
	short y;
	
	for(x = xI;x < xF; x++)
	{
		for(y = yI; y < yF; y++)
		{
			GrayClipSprite32_XOR_R((x<<5)-engine.x, (y*30)-engine.y, 30, &tileSprites[MAP_TILE(y, x).sprite*60], &tileSprites[MAP_TILE(y, x).sprite*60]+30, engine.light_vscreen, engine.dark_vscreen);
		
			#ifdef DRAW_BOXES
			if(MAP_TILE(y, x).boxType)
				DrawGrayRect2B((x<<5) - engine.x + MAP_TILE(y, x).x1, (y*30) - engine.y + MAP_TILE(y, x).y1, 
				               (x<<5) - engine.x + MAP_TILE(y, x).x2, (y*30) - engine.y + MAP_TILE(y, x).y2, 
				               COLOR_BLACK, 0, engine.light_vscreen, engine.dark_vscreen);
			#endif
		}
	}
	
	#ifdef SHOW_DOORS
	for(x = 0; x < map[engine.mapI].numOfDoors; x++)
	{
		DrawGrayRect2B(map[engine.mapI].door[x].eX + map[engine.mapI].door[x].pX - engine.x,
									 map[engine.mapI].door[x].eY + map[engine.mapI].door[x].pY - engine.y,
									 map[engine.mapI].door[x].eX + map[engine.mapI].door[x].pX - engine.x + 15,
									 map[engine.mapI].door[x].eY + map[engine.mapI].door[x].pY - engine.y + 15,
									 COLOR_LIGHTGRAY, 1, engine.light_vscreen, engine.dark_vscreen);
	}
	#endif
}

#define ENEMY_SPEED (3 + GET_ENEMY(i).speed)

// Updates the Enemies Pos
void UpdateEnemies()
{
	uchar i;
	
	for( i = 0; i < map[engine.mapI].numOfEnemies; i++)
	{
		if(MAP_ENEMY(i).currentHP <= 0)
		{
			MAP_ENEMY(i).deadTime++;
			
			if(MAP_ENEMY(i).deadTime > GET_ENEMY(i).spawnTime)
			{
				// reset dead variables
				MAP_ENEMY(i).currentHP = GET_ENEMY(i).maxHP;
				MAP_ENEMY(i).deadTime = 0;
				
				// Set new position
				RandomizePosition(i);
			}
			else continue;
		}

		// if in attack mode
		if(MAP_ENEMY(i).attackTime > 0)
		{
			// go back and forth between frames
			if(++MAP_ENEMY(i).attackTime > 5)
			{
				MAP_ENEMY(i).attackTime = 1;
				if(++MAP_ENEMY(i).frame == GET_ENEMY(i).frames)
					MAP_ENEMY(i).frame = 0;
			}
			
			// move towards the player
			short d = (MAP_ENEMY(i).x - engine.x - player.xPos) * -MAP_ENEMY(i).dir;
			if(d > 140)
			{
				MAP_ENEMY(i).attackTime = 0;
				MAP_ENEMY(i).frame = 0;
			}
			else if(d > 40) 
			{
				MAP_ENEMY(i).dir *= -1;

				if(GET_ENEMY(i).isFlying)
				{
					MAP_ENEMY(i).xVel *= -1;
					MAP_ENEMY(i).yVel = (MAP_ENEMY(i).y - engine.y - player.yPos) * MAP_ENEMY(i).xVel / (d * -MAP_ENEMY(i).dir);
				}
			}
		}
		
		if(GET_ENEMY(i).isFlying)
		{
			Enemy_MoveVel(i);
		}
		else
		{
			// For jumpers
			if(GET_ENEMY(i).jumpSpeed != 0 && MAP_ENEMY(i).walkTime > GET_ENEMY(i).walkTime)
			{ MAP_ENEMY(i).yVel = GET_ENEMY(i).jumpSpeed; MAP_ENEMY(i).walkTime = 0; MAP_ENEMY(i).isJumping = 1;}
			
			// Gravity and sliding
			MAP_ENEMY(i).yVel -= 2;
			Enemy_MoveVel(i);
			if(MAP_ENEMY(i).walkTime > 100) MAP_ENEMY(i).walkTime = 0;
				
			// Check for walking on boxes
			short tempX = MAP_ENEMY(i).x + (10 + ENEMY_SPEED) * -MAP_ENEMY(i).dir;
			short t = (MAP_ENEMY(i).yVel != 0 || MAP_ENEMY(i).attackTime != 0 || MAP_ENEMY(i).isJumping != 0) ? 1 : CheckEnemyTileOverlap(tempX, MAP_ENEMY(i).y + 1, GET_ENEMY(i).bytes * 8, GET_ENEMY(i).sprite_len, 0);
			
			// Switch direction
			if(t == -1 || 
				(MAP_ENEMY(i).x < 16 && MAP_ENEMY(i).dir == -BACKWARD) || 
				(MAP_ENEMY(i).x > MAP_WIDTH - 20 - GET_ENEMY(i).bytes * 8 && MAP_ENEMY(i).dir == -FORWARD))
				MAP_ENEMY(i).dir *= -1;
			
			// Walking / Jumpin motion
			Enemy_MoveX(i, ENEMY_SPEED * -MAP_ENEMY(i).dir);		
		}
	}
}

// Draw Enemies
void DrawEnemies()
{
	uchar i;
	
	for( i = 0; i < map[engine.mapI].numOfEnemies; i++)
	{
		#ifdef SHOW_SPAWN_BOXES
		DrawGrayRect2B(MAP_ENEMY(i).box_x0 - engine.x, MAP_ENEMY(i).box_y0 - engine.y,
									 MAP_ENEMY(i).box_x1 - engine.x, MAP_ENEMY(i).box_y1 - engine.y,
									 COLOR_DARKGRAY, 0, engine.light_vscreen, engine.dark_vscreen);
		#endif

		if(MAP_ENEMY(i).currentHP > 0 &&
		   MAP_ENEMY(i).x > engine.x - GET_ENEMY(i).bytes * 4 && MAP_ENEMY(i).x < engine.x + SCREEN_WIDTH &&
			 MAP_ENEMY(i).y > engine.y - GET_ENEMY(i).sprite_len && MAP_ENEMY(i).y < engine.y + SCREEN_HEIGHT)
		{
			void *sprite = 0;			
			switch(GET_ENEMY(i).bytes)
			{
			case 1:
				sprite = (void*)(((MAP_ENEMY(i).dir == FORWARD) ? &enemySprite_8[GET_ENEMY(i).sprite] : &enemySprite_r_8[GET_ENEMY(i).sprite]) + (GET_ENEMY(i).sprite_len * 3 *  MAP_ENEMY(i).frame));
				GrayClipSprite8_SMASK_R(MAP_ENEMY(i).x - engine.x, MAP_ENEMY(i).y - engine.y, GET_ENEMY(i).sprite_len, (uchar*)sprite, (uchar*)sprite+GET_ENEMY(i).sprite_len, (uchar*)sprite+2*GET_ENEMY(i).sprite_len, engine.light_vscreen, engine.dark_vscreen);
				break;
			case 2:
				sprite = (void*)(((MAP_ENEMY(i).dir == FORWARD) ? &enemySprite_16[GET_ENEMY(i).sprite] : &enemySprite_r_16[GET_ENEMY(i).sprite]) + (GET_ENEMY(i).sprite_len * 3 *  MAP_ENEMY(i).frame));
				GrayClipSprite16_SMASK_R(MAP_ENEMY(i).x - engine.x, MAP_ENEMY(i).y - engine.y, GET_ENEMY(i).sprite_len, (ushort*)sprite, (ushort*)sprite+GET_ENEMY(i).sprite_len, (ushort*)sprite+2*GET_ENEMY(i).sprite_len, engine.light_vscreen, engine.dark_vscreen);
				break;
			case 4:
				sprite = (void*)(((MAP_ENEMY(i).dir == FORWARD) ? &enemySprite_32[GET_ENEMY(i).sprite] : &enemySprite_r_32[GET_ENEMY(i).sprite]) + (GET_ENEMY(i).sprite_len * 3 *  MAP_ENEMY(i).frame));
				GrayClipSprite32_SMASK_R(MAP_ENEMY(i).x - engine.x, MAP_ENEMY(i).y - engine.y, GET_ENEMY(i).sprite_len, (ulong*)sprite, (ulong*)sprite+GET_ENEMY(i).sprite_len, (ulong*)sprite+2*GET_ENEMY(i).sprite_len, engine.light_vscreen, engine.dark_vscreen);
				break;
			case 8:
				break;
			}
			
			#ifdef DRAW_BOXES
			DrawGrayRect2B(MAP_ENEMY(i).x - engine.x, MAP_ENEMY(i).y - engine.y, MAP_ENEMY(i).x - engine.x + GET_ENEMY(i).bytes * 8 - 1, MAP_ENEMY(i).y - engine.y + GET_ENEMY(i).sprite_len - 1, COLOR_BLACK, 0, engine.light_vscreen, engine.dark_vscreen);
			#endif
		}
	}
}

// Draws all of the drops
void DrawItemDrops()
{
	uchar i;
	for(i = 0; i < map[engine.mapI].numOfDrops; i++)
	{
		if(map[engine.mapI].drops[i].x > engine.x - 8 && map[engine.mapI].drops[i].x < engine.x + SCREEN_WIDTH &&
			 map[engine.mapI].drops[i].y > engine.y - 8 && map[engine.mapI].drops[i].y < engine.y + SCREEN_HEIGHT)
		{
			GrayClipSprite8_SMASK_R(map[engine.mapI].drops[i].x - engine.x, map[engine.mapI].drops[i].y - engine.y, 8, ITEMSPRITE(map[engine.mapI].drops[i].index), ITEMSPRITE(map[engine.mapI].drops[i].index)+8, ITEMSPRITE(map[engine.mapI].drops[i].index)+16, engine.light_vscreen, engine.dark_vscreen);
		}
	}
}

// Adds an fstring to the array
void NewFString(char str[9], short x, short y)
{
	if(engine.numfStrings < NUM_FSTRING)
	{
		memcpy(engine.dmg[engine.numfStrings].string, str, 9*sizeof(char));
		engine.dmg[engine.numfStrings].x = x;
		engine.dmg[engine.numfStrings].y = y;
		engine.dmg[engine.numfStrings].time = 25;
		engine.numfStrings++;
	}
}

#ifdef USE_CSTRINGS
// Adds a cString to the array
void NewCString(char str[30])
{
	if(engine.numcStrings == 3)
	{
		memcpy(&engine.text[0], &engine.text[1], sizeof(cString));
		memcpy(&engine.text[1], &engine.text[2], sizeof(cString));

		memcpy(engine.text[2].string, str, 30*sizeof(char));
		engine.text[2].time = 50;
	}
	else
	{
		memcpy(engine.text[engine.numcStrings].string, str, 30*sizeof(char));
		engine.text[engine.numcStrings].time = 50;
		engine.numcStrings++;
	}
}
#endif

// Draws the floating strings
void DrawFStrings()
{
	uchar i;
	FontSetSys(F_6x8);
	for(i = 0; i < engine.numfStrings; i++)
	{
		if(engine.dmg[i].x > engine.x && engine.dmg[i].x < engine.x + SCREEN_WIDTH - 10 &&
			 engine.dmg[i].y > engine.y && engine.dmg[i].y < engine.y + SCREEN_HEIGHT - 5)
		{
			GrayDrawStr2B(engine.dmg[i].x - engine.x, engine.dmg[i].y - engine.y, engine.dmg[i].string, A_NORMAL, engine.light_vscreen, engine.dark_vscreen);
		}
			
		if((engine.dmg[i].time & 0x03) == 0)
			engine.dmg[i].y--;

		if(--engine.dmg[i].time == 0)
			memcpy(&engine.dmg[i--], &engine.dmg[--engine.numfStrings], sizeof(fString));
	}

	FontSetSys(F_4x6);
}

#ifdef USE_CSTRINGS
// Draws the command (text) strings
void DrawCStrings()
{
	uchar i;
	for(i = 0; i < engine.numcStrings; i++)
	{
		GrayDrawStr2B(3, 88 - i*7, engine.text[i].string, A_NORMAL, engine.light_vscreen, engine.dark_vscreen);

		if(engine.text[i].time == 0)
		{
			uchar j; 
			for(j = i+1; j < engine.numcStrings; j++)
				memcpy(&engine.text[j-1], &engine.text[j], sizeof(cString));

			i--;
			engine.numcStrings--;
		}
	}
}
#endif

#ifdef VIEW_ITEMS
// Views all the items
void ViewItems()
{
	uchar i = 0;

	char val[] = "Value: 000000", uFor[] = "Use Type: 0", uI[] = "Use Index: 00", dmg[] = "Damage: 00";

	while(!prev_keys.Esc)
	{
		// Clear buffer screens
		memset(engine.light_vscreen, 0x00, 3840);
		memset(engine.dark_vscreen, 0x00, 3840);
		
		// Keys
		ScanKeys();

		if(keys.Left && i-- < 1) i = NUM_ITEMS - 1;
		else if(keys.Right && ++i >= NUM_ITEMS) i = 0;

		SetPrevKeys();

		GrayClipSprite8_SMASK_R(1, 1, 8, ITEMSPRITE(i), ITEMSPRITE(i)+8, ITEMSPRITE(i)+16, engine.light_vscreen, engine.dark_vscreen);
		GrayDrawStr2B(11, 2, items[i].name, A_NORMAL, engine.light_vscreen, engine.dark_vscreen);

		sprintf(val+7, "%ld", items[i].value);
		GrayDrawStr2B(3, 15, val, A_NORMAL, engine.light_vscreen, engine.dark_vscreen);

		sprintf(uFor+10, "%d", items[i].useType);
		GrayDrawStr2B(3, 25, uFor, A_NORMAL, engine.light_vscreen, engine.dark_vscreen);

		sprintf(uI+11, "%d", items[i].useIndex);
		GrayDrawStr2B(3, 35, uI, A_NORMAL, engine.light_vscreen, engine.dark_vscreen);

		if(items[i].useType == WEAPON)
		{
			sprintf(dmg+8, "%d", GetWeaponDamage(items[i].useIndex));
			GrayDrawStr2B(3, 45, dmg, A_NORMAL, engine.light_vscreen, engine.dark_vscreen);
		}
		
		// Copy over buffer screen
		FastCopyScreen(engine.light_vscreen, GetPlane(LIGHT_PLANE));
		FastCopyScreen(engine.dark_vscreen, GetPlane(DARK_PLANE));
	}
}
#endif

// Gets Keys
void GetKeys()
{
	// Gets the keys	
	ScanKeys();
	
	// Does stuff with the keys
	if(keys.Esc && !prev_keys.Esc) 
	{ QuickSave(); MainMenu();}
	
	if(keys.Left)
	{
		player.direction = BACKWARD;
		MoveX(-SPEED);
		
		if(player.xVel > 0) player.xVel--;
	}
	else if(keys.Right)
	{
		player.direction = FORWARD;
		MoveX(SPEED);
		
		if(player.xVel < 0) player.xVel++;
	}
	
	if(keys.Diamond)
	{
		if(player.jump_time == 0)
		{
			player.yVel = 9;
		}
		else if(player.jump_time < 5 && prev_keys.Diamond)
		{
			player.yVel+=3;
		}
	}
	
	if(keys._2nd && !player.attack && !player.magic_time)
	{
		player.attack = 1;
		player.still_time = 0;
	}
	
	if(keys.Down && !prev_keys.Down) PickUpItem();

	if(keys.Up && !prev_keys.Up)
	{
		short t = CheckTileOverlap(player.xPos, player.yPos, 2);
		if(t != -1 && tiles[map[engine.mapI].terrain[t]].boxType == DOOR)
		{
			// Quick Save
			QuickSave();

			// Load Map
			uchar i;
			for(i = 0; i < map[engine.mapI].numOfDoors; i++)
				if(map[engine.mapI].doorI[i] == t)
					LoadMap(map[engine.mapI].door[i].area,
					        map[engine.mapI].door[i].map, 
									map[engine.mapI].door[i].door);
		}
	}
	
	if(keys.Shift) ShowInventory(0);

	if(keys.Alpha && !prev_keys.Alpha && !player.magic_time && !player.attack && player.magic >= 5) 
	{
		player.magic_time = 10;
		player.magic -= 5;
	}

#ifdef VIEW_ITEMS
	if(keys.Alpha) ViewItems();
#endif

	if(keys.Home) ShowStats();

	if(keys.Enter && !prev_keys.Enter) DrawMiniMap();

	if(keys.F1 && !prev_keys.F1 && player.F_Key[0] != -1) UseItem(player.F_Key[0]);
	if(keys.F2 && !prev_keys.F2 && player.F_Key[1] != -1) UseItem(player.F_Key[1]);
	if(keys.F3 && !prev_keys.F3 && player.F_Key[2] != -1) UseItem(player.F_Key[2]);
	if(keys.F4 && !prev_keys.F4 && player.F_Key[3] != -1) UseItem(player.F_Key[3]);
	if(keys.F5 && !prev_keys.F5 && player.F_Key[4] != -1) UseItem(player.F_Key[4]);
	
	SetPrevKeys();
}

// Loads a map & sets all the necessary variables
void LoadMap(uchar area, uchar i, uchar j)
{
	// Load the correct area
	LoadArea(area);

	// Set the new map
	engine.mapI = i;

	// Load the tile set for the new map
	LoadTileSet(map[i].tileSet);

	engine.x = map[i].door[j].eX;
	engine.y = map[i].door[j].eY;

	player.xPos = map[i].door[j].pX;
	player.yPos = map[i].door[j].pY;

	ResetMapEnemies();
}

static char tileName[] = "mtile00";

// Loads a Tile Set
void LoadTileSet(uchar i)
{
	if(i != engine.tileSet)
	{
		engine.tileSet = i;

		tileName[5] = i / 10 + '0';
		tileName[6] = i % 10 + '0';
		
		SYM_STR filename = SYMSTR(tileName);

		SYM_ENTRY *symentry;
		HANDLE saveData;
		MULTI_EXPR *ptr;
		HSym h;

		//Step 1: Find the file, return if not found
		symentry = SymFindPtr(filename, 0);
		if(!symentry) return Crash(ERROR_FILE);
		
		saveData = symentry->handle;
		ptr = HeapDeref(saveData);

		//Step 2: Copy over necessary data
		memcpy(&numOfTiles, ptr->Expr, sizeof(uchar));
		SetTiles(numOfTiles);

		memcpy(tiles, ptr->Expr + sizeof(uchar), numOfTiles*sizeof(TILES));
		memcpy(tileSprites, ptr->Expr + sizeof(uchar) + numOfTiles*sizeof(TILES), numOfTiles*60*sizeof(ulong));
		memcpy(miniTileSprites, ptr->Expr + sizeof(uchar) + numOfTiles*sizeof(TILES) + numOfTiles*60*sizeof(ulong), numOfTiles*8*sizeof(uchar));
	}
}

// Menu Method
void MainMenu()
{
	uchar tab = 0;
	uchar index = 0;

	while(1)
	{
		FastCopyScreen(GetPlane(LIGHT_PLANE), engine.light_vscreen); 
		FastCopyScreen(GetPlane(DARK_PLANE), engine.dark_vscreen);

		GrayDrawRect2B(49, 19, 111, 71, COLOR_BLACK, 0, engine.light_vscreen, engine.dark_vscreen);
		GrayDrawRect2B(50, 20, 110, 70, COLOR_LIGHTGRAY, 1, engine.light_vscreen, engine.dark_vscreen);
		GrayDrawStr2B(55, 22, "Main", A_NORMAL, engine.light_vscreen, engine.dark_vscreen);
		GrayDrawStr2B(85, 22, "Game", A_NORMAL, engine.light_vscreen, engine.dark_vscreen);
		GrayInvertRect2B(51 + 30*tab, 21, 79 + 30*tab, 27, engine.light_vscreen, engine.dark_vscreen);
		GrayFastDrawHLine2B(49, 111, 29, COLOR_BLACK, engine.light_vscreen, engine.dark_vscreen);
		
		FontSetSys(F_6x8);
		if(tab == 0)
		{
			GrayDrawStr2B(53, 32, "Continue", A_NORMAL, engine.light_vscreen, engine.dark_vscreen);
			GrayDrawStr2B(53, 42, "Save Game", A_NORMAL, engine.light_vscreen, engine.dark_vscreen);
			GrayDrawStr2B(53, 52, "Load Game", A_NORMAL, engine.light_vscreen, engine.dark_vscreen);
			GrayDrawStr2B(53, 62, "Exit", A_NORMAL, engine.light_vscreen, engine.dark_vscreen);
		}
		else
		{
			GrayDrawStr2B(53, 32, "Stats", A_NORMAL, engine.light_vscreen, engine.dark_vscreen);
			GrayDrawStr2B(53, 42, "Inventory", A_NORMAL, engine.light_vscreen, engine.dark_vscreen);
			GrayDrawStr2B(53, 52, "Abilities", A_NORMAL, engine.light_vscreen, engine.dark_vscreen);
		}
		FontSetSys(F_4x6);

		GrayInvertRect2B(51, 31 + index * 10, 109, 39 + index * 10, engine.light_vscreen, engine.dark_vscreen);

		CopyBuffers();

		do { SetPrevKeys(); ScanKeys(); }
		while((!keys.Esc || prev_keys.Esc) && (!keys.Left || prev_keys.Left) &&
			    (!keys.Right || prev_keys.Right) && (!keys.Up || prev_keys.Up) &&
					(!keys.Down || prev_keys.Down) && !keys._2nd);

		if(keys.Esc) { tab = 0; index = 3; }
		else if(keys._2nd)
		{
			if(tab == 0)
			{
				if(index == 1)
					MenuSave();
				else if(index == 2)
				{
					MenuLoad();

					// Loads the correct area
					LoadArea(++engine.area - 1);

					// Loads the correct tile set
					LoadTileSet(++engine.tileSet - 1);

					// Reset all the enemy vars
					ResetMapEnemies();
				}
				else if(index == 3) End();
			}
			else
			{
				if(index == 0)
					ShowStats();
				else if(index == 1)
					ShowInventory(0);
				//else
				//	ShowSkills();
			}

			SetPrevKeys();

			return;
		}

		if(keys.Left || keys.Right)
		{
			tab = 1 - tab;
			index = 0;
		}

		if(tab == 1)
		{
			if(keys.Up && index-- == 0) index = 2;
			if(keys.Down && ++index > 2) index = 0;
		}
		else
		{
			if(keys.Up && index-- == 0) index = 3;
			if(keys.Down && ++index > 3) index = 0;
		}
	}
}

#ifdef DEBUG
void _Assert(short condition, char str[50])
{
	if(condition == 0)
	{
		ClearBuffers();
		
		ClearGrayScreen2B(engine.light_vscreen, engine.dark_vscreen);
		DrawGrayStr2B(0, 40, str, A_NORMAL, engine.light_vscreen, engine.dark_vscreen);
		DrawGrayStr2B(10, 50, "is false.", A_NORMAL, engine.light_vscreen, engine.dark_vscreen);
		
		CopyBuffers();
		
		ScanKeys();
		
		while(!keys.Enter && !keys.Esc)
			ScanKeys();
			
		if(keys.Esc) End();
			
		SetPrevKeys();
	}
}

void _Print(char str[30])
{
	ClearBuffers();
	
	ClearGrayScreen2B(engine.light_vscreen, engine.dark_vscreen);
	DrawGrayStr2B(0, 40, str, A_NORMAL, engine.light_vscreen, engine.dark_vscreen);
	
	CopyBuffers();
	
	do
	{ SetPrevKeys(); ScanKeys(); }
	while(!keys.Enter || prev_keys.Enter);
}
#endif

#define QUICKSAVE_FILENAME "quicksav"
static char saveGameTag[]={0,'M','a','p','l',0,OTH_TAG};

// Quick Save / Load
char QuickSave()
{
	SYM_STR filename = SYMSTR(QUICKSAVE_FILENAME);
	HSym h = SymFind(filename);

	// Delete old file
	if(h.folder) 
		SymDel(filename);

	// Add new file
	h = SymAdd(filename);

	// Error
	if(!h.folder) 
		return 0;

	// Save
	return SaveGame(h);
}

char QuickLoad()
{
	SYM_STR filename = SYMSTR(QUICKSAVE_FILENAME);
	HSym h = SymFind(filename);

	// Check for file
	if(!h.folder) 
		return 0;

	// Load
	return LoadGame(h);
}

ESQ tag[] = {OTH_TAG, 0};
char type[] = "Mapl";

// Menu to Save / Load
char MenuSave()
{
	GrayOff();
	SetIntVec(AUTO_INT_1,engine.ai1);
	SetIntVec(AUTO_INT_5,engine.ai5);

	char *types[] = {type, 0};
	HSym h = VarSaveAs(tag, NULL, types);

	SetIntVec(AUTO_INT_1,DUMMY_HANDLER);
	SetIntVec(AUTO_INT_5,DUMMY_HANDLER);
	GrayOn();

	// Error
	if(!h.folder) 
		return 0;

	// Save
	return SaveGame(h);
}

char MenuLoad()
{
	GrayOff();
	SetIntVec(AUTO_INT_1,engine.ai1);
	SetIntVec(AUTO_INT_5,engine.ai5);

	char *types[] = {type, 0};
	HSym h = VarOpen(tag, types);

	SetIntVec(AUTO_INT_1,DUMMY_HANDLER);
	SetIntVec(AUTO_INT_5,DUMMY_HANDLER);
	GrayOn();

	// Check for file
	if(!h.folder) 
		return 0;

	// Load
	return LoadGame(h);
}

// Saves & Loads game
char SaveGame(HSym sym)
{
	SYM_ENTRY *symentry;
	HANDLE saveData;
	MULTI_EXPR *ptr;

	// Allocate the memory, store save data into the memory, and store the
	//   file type tag into memory.
	saveData = HeapAlloc(2 + sizeof(Player) + sizeof(ENGINE) + sizeof(saveGameTag));
	if(!saveData)
	{
		HSymDel(sym);
		return 0;
	}
	ptr = HeapDeref(saveData);
	ptr->Size = sizeof(Player) + sizeof(ENGINE) + sizeof(saveGameTag);

	memcpy(ptr->Expr, &player, sizeof(Player));
	memcpy(ptr->Expr + sizeof(Player), &engine, sizeof(ENGINE));
	memcpy(ptr->Expr + sizeof(Player) + sizeof(ENGINE), saveGameTag, sizeof(saveGameTag));

	// Associate the memory with your newly created file symbol
	symentry = DerefSym(sym);
	symentry->handle = saveData;

	return 1;
}

char LoadGame(HSym sym)
{
	SYM_ENTRY *symentry;
	HANDLE saveData;
	MULTI_EXPR *ptr;

	// Get the data
	symentry = DerefSym(sym);
	saveData = symentry->handle;
	ptr = HeapDeref(saveData);
	if(ptr->Size != sizeof(Player) + sizeof(ENGINE) + sizeof(saveGameTag))
		//Crash(ERROR_FILE);
		return 0;
	
	// Save data that shouldnt be overwritten
	void *l = engine.light_vscreen, *d = engine.dark_vscreen;
	INT_HANDLER ai1 = engine.ai1, ai5 = engine.ai5;

	// Copy over necessary data
	memcpy(&player, ptr->Expr, sizeof(Player));
	memcpy(&engine, ptr->Expr + sizeof(Player), sizeof(ENGINE));
	engine.light_vscreen = l;
	engine.dark_vscreen = d;
	engine.ai1 = ai1;
	engine.ai5 = ai5;

	return 1;
}



