// Header File
// Created 1/17/2008; 6:53:31 PM

#ifndef __GRAPHICS_H__
#define __GRAPHICS_H__

//#include "object.h"
//#include "extgraph.h"

#include "C:\Users\Nick\Documents\C Programming\TI-89 files\MapleCal\MapleCal\object.h"
#include "C:\Users\Nick\Documents\C Programming\TI-89 files\MapleCal\MapleCal\extgraph.h"

//#include "C:\Users\Joseph\Desktop\Calculator Programing stuff\Maplecalc\MapleCal\object.h"
//#include "C:\Users\Joseph\Desktop\Calculator Programing stuff\Maplecalc\MapleCal\extgraph.h"

#define MAP_TILE(Y,X) tiles[map[engine.mapI].terrain[Y*MAP_X+X]]

#define NUM_FSTRING 10

typedef struct
{
	char string[9];
	uchar time;

	short x;
	short y;
} fString;

#ifdef USE_CSTRINGS
typedef struct
{
	char string[30];
	uchar time;
} cString;
#endif

typedef struct
{
	// Position of top left corner of screen
	short x;
	short y;
	
	// Current map index
	uchar area;
	uchar mapI;
	uchar tileSet;
	
	// Iteration number
	uchar iteration;

	// Screen buffers
	void *light_vscreen, *dark_vscreen;

	// Interupts
	INT_HANDLER ai1,ai5;
	
	// Arrows
	ARROW arrows[MAX_ARROWS];
	uchar numArrows;

	// floating strings
	fString dmg[NUM_FSTRING];
	uchar numfStrings;

#ifdef USE_CSTRINGS
	// command prompt strings
	cString text[3];
	uchar numcStrings;
#endif
	
} ENGINE;

extern ENGINE engine;

// Clears the graphics
inline void ClearBuffers() { memset(engine.light_vscreen, 0x00, 3840); memset(engine.dark_vscreen, 0x00, 3840); }
inline void CopyBuffers() { FastCopyScreen(engine.light_vscreen, GetPlane(LIGHT_PLANE)); FastCopyScreen(engine.dark_vscreen, GetPlane(DARK_PLANE)); }

// Initialize everything
void Init();

// Main loop for drawing
void DrawLoop();

// Adds an fString to the array
void NewFString(char str[9], short x, short y);

// Saves & Loads game
char QuickSave();
char QuickLoad();

char MenuSave();
char MenuLoad();

char SaveGame(HSym sym);
char LoadGame(HSym sym);

// Menu Method
void MainMenu();

#ifdef USE_CSTRINGS
// Adds a cString to the array
void NewCString(char str[30]);
#endif

#endif // __GRAPHICS_H__
