// C Source File
// Created 2/2/2008; 5:22:09 PM

//#include "item.h"
#include "C:\Users\Nick\Documents\C Programming\TI-89 files\MapleCal\MapleCal\item.h"
//#include "C:\Users\Joseph\Desktop\Calculator Programing stuff\Maplecalc\MapleCal\item.h"

ITEM items[NUM_ITEMS];

#define NewItem(I, VAL, SPRITE) items[I].sprite = SPRITE; memcpy(items[I].name, iNames[I], MAX_NAME_LENGTH+1); items[I].value = VAL;
#define NewUseable(I, VAL, SPRITE, uINDEX) NewItem(I, VAL, SPRITE) items[I].useType = USEABLE; items[I].useIndex = uINDEX;
#define NewCollectable(I, VAL, SPRITE, uINDEX) NewItem(I, VAL, SPRITE) items[I].useType = COLLECTABLE; items[I].useIndex = uINDEX;
#define NewAmmo(I, VAL, SPRITE, uINDEX) NewItem(I, VAL, SPRITE) items[I].useType = AMMO; items[I].useIndex = uINDEX;
#define NewWeapon(I, VAL, SPRITE, uINDEX) NewItem(I, VAL, SPRITE) items[I].useType = WEAPON; items[I].useIndex = uINDEX;
#define NewArmor(I, VAL, SPRITE, uINDEX) NewItem(I, VAL, SPRITE) items[I].useType = ARMOR; items[I].useIndex = uINDEX;

void InitializeItems()
{	
	char iNames[NUM_ITEMS][MAX_NAME_LENGTH+1] = 
	{
	"Zin", "Potion", "Elixir", 
	"Wooden Arw", "Steel Arw", "Poison Arw", "Razor Arw", "Flame Arw",
	"Dagger", "Short Sword", "Bastard Swd", "Long Sword", "Master Swd",
	"Hunters Axe", "Iron Axe", "Steel Axe", "Great Axe", "Battle Axe",
	"Wooden Spr", "Steel Spr", "Barbed Spr", "Halberd", "Dragon Bone",
	"Shortbow", "Hunters Bow", "Oakbow", "Yewbow", "Ebonybow",
	"Nematode", "Scarab", "Werewolf", "Dragon", "Phoenix",
	"Cloth", "Leather", "Chain Mail", "Plate Mail", "Spring", "Spike Ball"
	};

	// Item 0 - Zin - "Money"
	NewCollectable(0, 1, 0, 0);
	
	// Item 1 - Potion - Heals you
	NewUseable(1, 100, 1, 0);
	
	// Item 2 - Elixer - Gives MP
	NewUseable(2, 200, 2, 1);
	
	// Item 3:7 - Arrows - Ammunition
	NewAmmo(3,   3, 3, 0);
	NewAmmo(4,   9, 3, 1);
	NewAmmo(5,  15, 3, 2);
	NewAmmo(6,  25, 3, 3);
	NewAmmo(7, 100, 3, 4);
	
	// Item 8:12 - Swords - Weapons
	NewWeapon( 8,   200, 4, 5);
	NewWeapon( 9,  1500, 4, 6);
	NewWeapon(10, 10000, 4, 7);
	NewWeapon(11, 25000, 4, 8);
	NewWeapon(12, 50000, 4, 9);
	
	// Item 13:17 - Axes - Weapons
	NewWeapon(13,   300, 5, 0);
	NewWeapon(14,  2000, 5, 1);
	NewWeapon(15,  8000, 5, 2);
	NewWeapon(16, 30000, 5, 3);
	NewWeapon(17, 55000, 5, 4);
	
	// Item 18:22 - Spears - Weapons
	NewWeapon(18,   500, 6, 20);
	NewWeapon(19,  3000, 6, 21);
	NewWeapon(20, 10000, 6, 22);
	NewWeapon(21, 40000, 6, 23);
	NewWeapon(22, 70000, 6, 24);
	
	// Item 23:27 - Bows - Weapons
	NewWeapon(23,   150, 7, 10);
	NewWeapon(24,  2000, 7, 11);
	NewWeapon(25,  9000, 7, 12);
	NewWeapon(26, 35000, 7, 13);
	NewWeapon(27, 60000, 7, 14);
	
	// Item 28:32 - Wands - Weapons
	NewWeapon(28,   100, 8, 15);
	NewWeapon(29,  1000, 8, 16);
	NewWeapon(30,  5000, 8, 17);
	NewWeapon(31, 25000, 8, 18);
	NewWeapon(32, 45000, 8, 19);

	// Item 33:36 - Armor
	NewArmor(33,   2000, 9, 0);
	NewArmor(34,  10000, 9, 1);
	NewArmor(35,  50000, 9, 2);
	NewArmor(36, 100000, 9, 3);

	// Collectable
	NewCollectable(37, 5, 10, 0);
	NewCollectable(38, 8, 11, 0);
}

// Drops a rare item (maybe) based off the strength of the enemy
uchar RareDrop(long hp_times_str)
{
	short r = random(100);
	short i = random(5)*5;

	if(hp_times_str > 1000000)
	{
		if(r < 3)       return i + 12;
		else if(r < 7)  return i + 11;
		else if(r < 10) return i + 10;
	}
	else if(hp_times_str > 100000)
	{
		if(r < 3)       return i + 11;
		else if(r < 7)  return i + 10;
		else if(r < 10) return i +  9;
	}
	else if(hp_times_str > 10000)
	{
		if(r < 3)       return i + 10;
		else if(r < 7)  return i +  9;
	}
	else if(hp_times_str > 1000)
	{
		if(r < 3)       return i +  9;
		else if(r < 7)  return i +  8;
	}
	else
	{
		if(r < 3)       return i + 8;
	}

	return 0;
}

