// Header File
// Created 2/2/2008; 5:22:04 PM

#ifndef __ITEM_H__
#define __ITEM_H__

//#include "globals.h"
#include "C:\Users\Nick\Documents\C Programming\TI-89 files\MapleCal\MapleCal\globals.h"
//#include "C:\Users\Joseph\Desktop\Calculator Programing stuff\Maplecalc\MapleCal\globals.h"


// Enums for the names of the items that correspond to their indices
enum ItemNames 
{ ITEM_ZIN = 0, ITEM_POTION = 1, ITEM_ELIXIR = 2, ITEM_WOODEN_ARW = 3, 
	ITEM_STEEL_ARW = 4, ITEM_POISON_ARW = 5, ITEM_RAZOR_ARW = 6, ITEM_FLAME_ARW = 7, 
	ITEM_DAGGER = 8, ITEM_SHORT_SWORD = 9, ITEM_BASTARD_SWORD = 10, ITEM_LONG_SWORD = 11,
	ITEM_MASTER_SWORD = 12, ITEM_HUNTERS_AXE = 13, ITEM_IRON_AXE = 14, ITEM_STEEL_AXE = 15,
	ITEM_GREAT_AXE = 16, ITEM_BATTLE_AXE = 17, ITEM_WOODEN_SPR = 18, ITEM_STEEL_SPEAR = 19,
	ITEM_BARBED_SPR = 20, ITEM_HALBERD = 21, ITEM_DRAGON_BONE = 22, ITEM_SHORTBOW = 23,
	ITEM_HUNTERS_BOW = 24, ITEM_OAKBOW = 25, ITEM_YEWBOW = 26, ITEM_EBONYBOW = 27,
	ITEM_NEMATODE = 28, ITEM_SCARAB = 29, ITEM_WEREWOLF = 30, ITEM_DRAGON = 31,
	ITEM_PHOENIX = 32, ITEM_SPRING = 37, ITEM_SPIKE_BALL = 38
};

enum AmmoBase   { _ARROW = 0, THROWINGSTAR = 1 };
enum WeaponBase { _SWORD = 0, AXE = 1, SPEAR = 2, BOW = 3, WAND = 4 };
enum ArmorBase  { CLOTH = 0, LEATHER = 1, CHAIN = 2, PLATE = 3 };

// The different types of uses for items
enum ItemUseType { USEABLE = 0, COLLECTABLE = 1, AMMO = 2, WEAPON = 3, ARMOR = 4 };

#define NUM_ITEMS 39
#define MAX_NAME_LENGTH 12

// Basic data for each item
typedef struct
{
	// Index to the picture of the item
	uchar sprite;
	
	// Name of the item
	char name[MAX_NAME_LENGTH+1];
	
	// Monetary value of the item
	long value;
	
	// How the item is used
	uchar useType;
	
	// This index is used in arrays based off of how the item is used
	uchar useIndex;
} ITEM;

// Used for dropping from monsters
typedef struct
{
	// Index for the item
	uchar index;
	
	// Chance for the drop to occur 1 - 100
	uchar chance;
	
	// Number of items dropped (random between 0.5*number - number)
	long number;
} DROP;

// Used for displaying on maps
typedef struct
{
	short x;
	short y;
	short yVel;
	
	uchar index;
	long number;
} DROP_DATA;

// Global list of all items
extern ITEM items[NUM_ITEMS];

// Creates all the items
void InitializeItems();

// Views all the items
void ViewItems();

// Drops a rare item (maybe) based off the strength of the enemy
uchar RareDrop(long hp_times_str);

#endif // __ITEM_H__

