// C Source File
// Created 1/24/2008; 4:34:52 PM

/*#include "map.h"
#include "graphics.h"
#include "keys.h"
#include "extgraph.h"
#include "player.h"*/

#include "C:\Users\Nick\Documents\C Programming\TI-89 files\MapleCal\MapleCal\map.h"
#include "C:\Users\Nick\Documents\C Programming\TI-89 files\MapleCal\MapleCal\graphics.h"
#include "C:\Users\Nick\Documents\C Programming\TI-89 files\MapleCal\MapleCal\keys.h"
#include "C:\Users\Nick\Documents\C Programming\TI-89 files\MapleCal\MapleCal\extgraph.h"
#include "C:\Users\Nick\Documents\C Programming\TI-89 files\MapleCal\MapleCal\player.h"

/*#include "C:\Users\Joseph\Desktop\Calculator Programing stuff\Maplecalc\MapleCal\map.h"
#include "C:\Users\Joseph\Desktop\Calculator Programing stuff\Maplecalc\MapleCal\graphics.h"
#include "C:\Users\Joseph\Desktop\Calculator Programing stuff\Maplecalc\MapleCal\keys.h"
#include "C:\Users\Joseph\Desktop\Calculator Programing stuff\Maplecalc\MapleCal\extgraph.h"
#include "C:\Users\Joseph\Desktop\Calculator Programing stuff\Maplecalc\MapleCal\player.h"*/

uchar numOfMaps;
MAP *map;

void InitializeMaps()
{
	map = NULL;
	engine.area = 255;
}

// Clears All the maps and their data
void DestructMaps()
{
	if(map != NULL)
	{
		uchar i;
		for(i = 0; i < numOfMaps; i++)
		{
			free(map[i].terrain);
			free(map[i].doorI);
			free(map[i].door);
			free(map[i].enemies);
		}

		free(map);
	}
}

// Sets the memory up for the maps
void SetMaps(uchar size)
{
	DestructMaps();

	map = (MAP*)malloc(size * sizeof(MAP));
}

// Resets some the the variables in the enemies
void ResetMapEnemies()
{
	uchar i;
	for(i = 0; i < map[engine.mapI].numOfEnemies; i++)
	{
		MAP_ENEMY(i).currentHP = GET_ENEMY(i).maxHP;
		MAP_ENEMY(i).xVel = 0;
		MAP_ENEMY(i).yVel = 0;
		MAP_ENEMY(i).attackTime = 0;
		MAP_ENEMY(i).frame = 0;
		RandomizePosition(i);
	}
}

// Damages the enemy and then drops items
void DamageEnemy(uchar i, long damage, char dir)
{
	damage -= GET_ENEMY(i).defense*3;
	if(damage < 0) damage = 0;

	char str[9];
	sprintf(str, "-%ld", damage);
	NewFString(str, MAP_ENEMY(i).x, MAP_ENEMY(i).y - 10);

	if(damage > 0)
	{	
		MAP_ENEMY(i).currentHP -= damage;
		MAP_ENEMY(i).attackTime++;

		if(dir > 0) { MAP_ENEMY(i).xVel =  7; MAP_ENEMY(i).dir = FORWARD; }
		else        { MAP_ENEMY(i).xVel = -7; MAP_ENEMY(i).dir = BACKWARD; }
		
		if(MAP_ENEMY(i).currentHP <= 0)
		{
			MAP_ENEMY(i).xVel = 0;
			MAP_ENEMY(i).yVel = 0;
			MAP_ENEMY(i).frame = 0;
			MAP_ENEMY(i).attackTime = 0;

			DropEnemyItems(i);

			player.experience += GET_ENEMY(i).exp;
		}
	}
}

// Drops the items from an enemy
void DropEnemyItems(uchar i)
{
	uchar j;
	for(j = 0; j < GET_ENEMY(i).numItemsDropped; j++)
	{
		// See if it is dropped
		if(random(100) < GET_ENEMY(i).drops[j].chance)
		{
			if(map[engine.mapI].numOfDrops < MAX_DROPS)
			{
				map[engine.mapI].drops[map[engine.mapI].numOfDrops].x = MAP_ENEMY(i).x + random(GET_ENEMY(i).bytes*8);
				map[engine.mapI].drops[map[engine.mapI].numOfDrops].y = MAP_ENEMY(i).y + GET_ENEMY(i).sprite_len - 8;
				
				map[engine.mapI].drops[map[engine.mapI].numOfDrops].index = GET_ENEMY(i).drops[j].index;
				if(GET_ENEMY(i).drops[j].number != 1)
					map[engine.mapI].drops[map[engine.mapI].numOfDrops].number = random(GET_ENEMY(i).drops[j].number>>1) + (GET_ENEMY(i).drops[j].number>>1);
				else
					map[engine.mapI].drops[map[engine.mapI].numOfDrops].number = 1;
				
				map[engine.mapI].numOfDrops++;
			}
		}
	}
	
	// Small chance of a Rare Weapon Drop
	if(map[engine.mapI].numOfDrops < MAX_DROPS)
	{
		uchar rareDrop = RareDrop(GET_ENEMY(i).maxHP * (long)GET_ENEMY(i).strength);
		if(rareDrop != 0)
		{
			map[engine.mapI].drops[map[engine.mapI].numOfDrops].x = MAP_ENEMY(i).x + random(GET_ENEMY(i).bytes*8);
			map[engine.mapI].drops[map[engine.mapI].numOfDrops].y = MAP_ENEMY(i).y + GET_ENEMY(i).sprite_len - 8;
			
			map[engine.mapI].drops[map[engine.mapI].numOfDrops].index = rareDrop;
			map[engine.mapI].drops[map[engine.mapI].numOfDrops].number = 1;
			
			map[engine.mapI].numOfDrops++;
		}
	}
}

// Deletes a drop from the array
void RemoveDrop(uchar i)
{
	if(map[engine.mapI].numOfDrops > 1)
		memcpy(&map[engine.mapI].drops[i], &map[engine.mapI].drops[map[engine.mapI].numOfDrops-1], sizeof(DROP_DATA));
		
	map[engine.mapI].numOfDrops--;
}

static char areaName[] = "marea00";

#define Read(X, Y) memcpy(X, ptr->Expr + size, Y); size += Y;

// Load Area
void LoadArea(uchar area)
{
	if(engine.area != area)
	{
		engine.area = area;

		areaName[5] = area / 10 + '0';
		areaName[6] = area % 10 + '0';
		
		SYM_STR filename = SYMSTR(areaName);

		SYM_ENTRY *symentry;
		HANDLE saveData;
		MULTI_EXPR *ptr;
		HSym h;

		//Step 1: Find the file, return if not found
		symentry = SymFindPtr(filename, 0);
		if(!symentry) return Crash(ERROR_FILE);
		
		saveData = symentry->handle;
		ptr = HeapDeref(saveData);

		//Step 2: Copy over necessary data
		long size = 0;
		Read(&numOfMaps, sizeof(uchar));
		SetMaps(numOfMaps);

		uchar i;
		for(i = 0; i < numOfMaps; i++)
		{
			memset(&map[i], 0x00, sizeof(MAP));
			Read(&map[i], sizeof(MAP_F));

			#ifdef DEBUG_AREA_FILE
			ClearBuffers();

			char str[25];
			sprintf(str, "Map %d", i+1);
			DrawGrayStr2B(0, 0, str, A_NORMAL, engine.light_vscreen, engine.dark_vscreen);
			sprintf(str, "Terrain: %d x %d", map[i].mapX, map[i].mapY);
			DrawGrayStr2B(5, 10, str, A_NORMAL, engine.light_vscreen, engine.dark_vscreen);
			sprintf(str, "DoorI: %d", map[i].numOfDoors);
			DrawGrayStr2B(5, 20, str, A_NORMAL, engine.light_vscreen, engine.dark_vscreen);
			sprintf(str, "Door: %d", map[i].numOfDoors);
			DrawGrayStr2B(5, 30, str, A_NORMAL, engine.light_vscreen, engine.dark_vscreen);
			sprintf(str, "Enemies: %d", map[i].numOfEnemies);
			DrawGrayStr2B(5, 40, str, A_NORMAL, engine.light_vscreen, engine.dark_vscreen);

			CopyBuffers();

			do
			{ SetPrevKeys(); ScanKeys(); }
			while(!keys.Enter || prev_keys.Enter);
			#endif

			map[i].terrain = (uchar*)malloc(map[i].mapX * map[i].mapY * sizeof(uchar));
			map[i].doorI = (short*)malloc(map[i].numOfDoors * sizeof(short));
			map[i].door = (DOOR_DATA*)malloc(map[i].numOfDoors * sizeof(DOOR_DATA));
			map[i].enemies = (ENEMY_DATA*)malloc(map[i].numOfEnemies * sizeof(ENEMY_DATA));

			Read(map[i].terrain, map[i].mapX * map[i].mapY * sizeof(uchar));
			Read(map[i].doorI, map[i].numOfDoors * sizeof(short));
			Read(map[i].door, map[i].numOfDoors * sizeof(DOOR_DATA));

			uchar j;
			for(j = 0; j < map[i].numOfEnemies; j++)
			{
				memset(&map[i].enemies[j], 0x00, sizeof(ENEMY_DATA));
				Read(&map[i].enemies[j], sizeof(ENEMY_DATA_F));

				map[i].enemies[j].currentHP = enemies[map[i].enemies[j].index].maxHP;
				map[i].enemies[j].dir = FORWARD;
			}
		}
	}
}



