// Header File
// Created 1/17/2008; 8:14:13 PM

#ifndef __PLAYER_H__
#define __PLAYER_H__

/*#include "globals.h"
#include "item.h"
#include "itemtype.h"
#include "enemy.h"*/


#include "C:\Users\Nick\Documents\C Programming\TI-89 files\MapleCal\MapleCal\globals.h"
#include "C:\Users\Nick\Documents\C Programming\TI-89 files\MapleCal\MapleCal\item.h"
#include "C:\Users\Nick\Documents\C Programming\TI-89 files\MapleCal\MapleCal\itemtype.h"
#include "C:\Users\Nick\Documents\C Programming\TI-89 files\MapleCal\MapleCal\enemy.h"

/*#include "C:\Users\Joseph\Desktop\Calculator Programing stuff\Maplecalc\MapleCal\globals.h"
#include "C:\Users\Joseph\Desktop\Calculator Programing stuff\Maplecalc\MapleCal\item.h"
#include "C:\Users\Joseph\Desktop\Calculator Programing stuff\Maplecalc\MapleCal\itemtype.h"
#include "C:\Users\Joseph\Desktop\Calculator Programing stuff\Maplecalc\MapleCal\enemy.h"*/


#define SPEED 4
#define TERMINAL_VEL -20

char jobNames[4][9] = { "Beginner", "Warrior", "Magician", "Bowman" };
char miss[9] = "Miss";

typedef struct
{
	long health;
	long magic;
	
	long maxHealth;
	long maxMagic;
	
	short xPos;
	short yPos;
	
	short xVel;
	short yVel;
	
	// index to sprite
	ushort head;
	
	// index to item
	uchar ammo;
	ushort weapon;
	ushort armor;
	uchar spell;

	// stats
	uchar job;
	ushort strength;
	ushort dexterity;
	ushort intelligence;
	ushort luck;
	ushort *abilites[4];

	// Leveling
	ulong experience;
	uchar level;
	uchar lPoints;
	uchar sPoints;
	
	// timing variables
	char direction;
	uchar attack;
	uchar jump_time;
	uchar still_time;
	uchar immune_time;
	uchar magic_time;
	
	short tile;
	
	// Items
	long items[NUM_ITEMS];
	
	// Skills
	uchar beginner_skills[NUM_BEGINNER_SKILLS];
	uchar warrior_skills[NUM_WARRIOR_SKILLS];
	uchar bowman_skills[NUM_BOWMAN_SKILLS];
	uchar magician_skills[NUM_MAGICIAN_SKILLS];
	uchar *skills[4];

	// Player set keys
	short F_Key[5];
} Player;

extern Player player;

// Initializes the variables
void InitializePlayer();
void CreatePlayer();

// Moves the player
void SetPlayerPos(ushort x, ushort y);
void MoveX(short x);
void MoveY(short y);
void MoveVel();
void AccelerateY(short yAcel);

// Checks over-laps with tiles
short CheckTileOverlap(short playerX, short playerY, uchar ignoreDanger);

// Attacks
void Attack();
void MagicAttack();

// Use Items
void UseItem(uchar i);

// Check if Player hits something that causes damage
void CheckPlayerDamage();
void DamagePlayer(long amount, short xDir, short yDir);

// Draws stats to the screen
void DrawPlayerStats();

// Picks up an item on the ground
void PickUpItem();

// Shows the Players inventory
void ShowInventory(uchar inStore);

// Shows the Players stats
void ShowStats();

// Show Skills
void ShowSkills();

// Gets the amount of experience to level to the next level, given the current level
ulong GetRequiredExp(uchar level);

// Returns the amount of damage done
#define GetDamage(X) _GetDamage(X, items[player.weapon].useIndex, items[player.ammo].useIndex)
inline void _GetDamage(long *dmg, uchar weapon, uchar ammo)
{
	switch(iWeapon[weapon].type)
	{
	case _SWORD:
		dmg[0] = ((float)player.strength * 4.6             + player.dexterity) * (float)GetWeaponDamage(weapon) * 0.01;
		dmg[1] = ((float)player.strength * 4.6 * 0.9 * 0.1 + player.dexterity) * (float)GetWeaponDamage(weapon) * 0.01;
		break;
	case AXE:
		dmg[0] = ((float)player.strength * 4.8             + player.dexterity) * (float)GetWeaponDamage(weapon) * 0.01;
		dmg[1] = ((float)player.strength * 3.4 * 0.9 * 0.1 + player.dexterity) * (float)GetWeaponDamage(weapon) * 0.01;
		break;
	case SPEAR:
		dmg[0] = ((float)player.strength * 5.0             + player.dexterity) * (float)GetWeaponDamage(weapon) * 0.01;
		dmg[1] = ((float)player.strength * 3.0 * 0.9 * 0.1 + player.dexterity) * (float)GetWeaponDamage(weapon) * 0.01;
		break;
	case BOW:
		dmg[0] = ((float)player.dexterity * 3.4             + player.strength) * (float)GetArrowDamage(weapon, ammo) * 0.01;
		dmg[1] = ((float)player.dexterity * 3.4 * 0.9 * 0.1 + player.strength) * (float)GetArrowDamage(weapon, ammo) * 0.01;
		break;
	case WAND:
		dmg[0] = (((float)player.intelligence * 0.8) + ((float)player.luck * 0.25)) / 18 * 0.8 * (float)GetWeaponDamage(weapon);
		dmg[1] = (((float)player.intelligence * 0.8) + ((float)player.luck * 0.20)) / 18 * 0.8 * (float)GetWeaponDamage(weapon) * 0.1;
		break;
	}
}

// returns 0 if not hit, 1 if hit
inline uchar EnemyGetHit(uchar _enemy)
{
	//calculates percent chance of missing and checking it against 100%
	
	if( random(100) < (float)((7 * (enemies[_enemy].avoid)) - (0.135 * (float)(player.dexterity/4 + player.luck/5))) )
		return 0;
	else
		return 1;
}

inline uchar PlayerGetHit(uchar _enemy)
{
	if( random(100) < ((1.25 * (float)(player.dexterity/5 + player.luck/3)) - (float)(1 * (enemies[_enemy].accuracy))) )
		return 0;
	else
		return 1;
}

inline void GetMagicDamage(long *dmg)
{
	dmg[0] = 10;
	dmg[1] = 3;
}

#endif // __PLAYER_H__
