
#ifndef __SKILL_H__
#define __SKILL_H__

//#include "globals.h"
#include "C:\Users\Nick\Documents\C Programming\TI-89 files\MapleCal\MapleCal\globals.h"
//#include "C:\Users\Joseph\Desktop\Calculator Programing stuff\Maplecalc\MapleCal\globals.h"

// Initialize all the skills
void InitializeSkills();

typedef struct
{
	// Name
	char name[15];
	uchar sprite;

	// Use
	uchar usedFor;
	uchar perTurn;
	uchar passive;

	// Formula amount = base + slope * x ^ exponent;
	uchar a_base;
	float a_slope;
	float a_expon;

	// Formula mp cost
	uchar mp_base;
	float mp_slope;
	float mp_expon;

	// Formula hp cost
	uchar hp_base;
	float hp_slope;
	float hp_expon;

	// Time
	ushort time;

	// Max level
	uchar maxLevel;

} Skill;

extern Skill beginner_skills[NUM_BEGINNER_SKILLS];
extern Skill warrior_skills[NUM_WARRIOR_SKILLS];
extern Skill bowman_skills[NUM_BOWMAN_SKILLS];
extern Skill magician_skills[NUM_MAGICIAN_SKILLS];

extern Skill *skills[4];
extern uchar skillSize[4];

// Returns the amount for the skill at a given level
inline ushort GetSkillAmount(uchar job, uchar _skill, uchar level)
{
	return (ushort)(skills[job][_skill].a_base + skills[job][_skill].a_slope * pow(level-1, skills[job][_skill].a_expon));
}

// Returns the mp cost
inline ushort GetSkillMPCost(uchar job, uchar _skill, uchar level)
{
	return (ushort)(skills[job][_skill].mp_base + skills[job][_skill].mp_slope * pow(level-1, skills[job][_skill].mp_expon));
}

// Returns the hp cost
inline ushort GetSkillHPCost(uchar job, uchar _skill, uchar level)
{
	return (ushort)(skills[job][_skill].hp_base + skills[job][_skill].hp_slope * pow(level-1, skills[job][_skill].hp_expon));
}

// Creates the new skill
inline void NewSkill(uchar job, uchar _skill, char *name, uchar sprite, uchar usedFor, uchar perTurn,
										 uchar a_base,  float a_slope,  float a_expon,
										 uchar mp_base, float mp_slope, float mp_expon,
										 uchar hp_base, float hp_slope, float hp_expon,
										 ushort time, uchar maxLevel, uchar passive)
{
	memcpy(skills[job][_skill].name, name, 15 * sizeof(char));
	skills[job][_skill].sprite = sprite;

	skills[job][_skill].usedFor = usedFor;
	skills[job][_skill].perTurn = perTurn;

	skills[job][_skill].a_base  = a_base;
	skills[job][_skill].a_slope = a_slope;
	skills[job][_skill].a_expon = a_expon;

	skills[job][_skill].mp_base  = mp_base;
	skills[job][_skill].mp_slope = mp_slope;
	skills[job][_skill].mp_expon = mp_expon;

	skills[job][_skill].hp_base  = hp_base;
	skills[job][_skill].hp_slope = hp_slope;
	skills[job][_skill].hp_expon = hp_expon;

	skills[job][_skill].time = time;
	skills[job][_skill].maxLevel = maxLevel;
	skills[job][_skill].passive = passive;
}

#endif // __SKILL_H__


